//Compare antialiasing using point sampling, linear, and mipmap

#include <stdio.h>
#include <GL/glut.h>
#include <stdlib.h>

char antiOption;
float myTrans=0.0;
//int startY; 
//int startMove=0;
static GLuint texName;


#define  winWidth 300
#define  winHeight 300
#define  imageWidth 512
#define  imageHeight 512

GLubyte Image[imageWidth][imageHeight][3];

void 
myImage()
{
  int i, j, c;

  for(i=0; i<imageWidth; i++)
    {
      for(j=0; j<imageHeight; j++)
	{
	  //c=((((i&0x8)==0)^((j&0x8))==0))*255;
	  c=((j&0x8)==0)*255;

	  Image[i][j][0]=(GLubyte)c;
	  Image[i][j][1]=(GLubyte)c;
	  Image[i][j][2]=(GLubyte)c;
	}
    }
}

void 
myInit()
{
  GLfloat magfilter, minfilter;

  glShadeModel(GL_FLAT);
  glEnable(GL_TEXTURE_2D);
  myImage();

  glGenTextures(1, &texName);
  glBindTexture(GL_TEXTURE_2D, texName);
  glClearColor(0.5, 0.5, 0.5, 1.0);

  switch(antiOption)
    {
    case 'p':
      magfilter=GL_NEAREST;
      minfilter=GL_NEAREST;      
      break;
    case 'l':
      magfilter=GL_LINEAR;
      minfilter=GL_LINEAR;      
      break;
    case 'm':
      magfilter=GL_LINEAR;
      minfilter=GL_LINEAR_MIPMAP_LINEAR;      
      break;
    }

  glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
  glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
  glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, magfilter);
  glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, minfilter);

  if(antiOption=='m')
    {
      int err= gluBuild2DMipmaps(GL_TEXTURE_2D, GL_RGB, imageWidth, 
				 imageHeight, GL_RGB, GL_UNSIGNED_BYTE, Image);

      if(err)
	printf("creating mipmap failed");
    }
  else
    glTexImage2D(GL_TEXTURE_2D, 0, GL_RGB, imageWidth, imageHeight, 0, GL_RGB, 
		 GL_UNSIGNED_BYTE, Image);

  //glHint(GL_POLYGON_SMOOTH_HINT, GL_NICEST);
}

void
myReshape(int w, int h)
{
  /* Set up projection transform. */
  glViewport(0, 0, (GLsizei)w, (GLsizei)h);
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  gluPerspective(90, 1, 1, 30);
  //glOrtho(-2.0, 2.0, -2.0, 2.0, 0.0, 2.0);
}

void
myDisplay()
{
  glClear(GL_COLOR_BUFFER_BIT);

  glBindTexture(GL_TEXTURE_2D, texName);
  glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_REPLACE);

  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
  //gluLookAt(0.0, 0.0, 0.0, 0.0, 0.0, -100.0, 0.0, 1.0, -1.0);

  glTranslatef(0.0, 0.0, myTrans);

  glBegin(GL_POLYGON);
  glTexCoord2f(0.0, 0.0); glVertex3f(-1.0, -1.0, -1.0);
  glTexCoord2f(1.0, 0.0); glVertex3f(1.0, -1.0, -1.0);
  glTexCoord2f(1.0, 1.0); glVertex3f(1.0, 0.0, -3.0);
  glTexCoord2f(0.0, 1.0); glVertex3f(-1.0, 0.0, -3.0);
  glEnd();

  glFlush();
}

/*
void
myMouse(int button, int state, int x, int y)
{
  if((state==GLUT_DOWN)&&(button==GLUT_LEFT_BUTTON))
    {
      startY=y;
      startMove=1;
    }
} 

void
myMotion(int x, int y)
{
  float d;

  if(y!=startY && startMove)
    {
      d=(float)(y-startY)/winHeight;
      myTrans=d*10;
      myDisplay();
    }
  startY=y;
}
*/

void
mySpecial(int key, int x, int y) 
{
  float near=myTrans+0.1;
  float far=myTrans-0.1;

  if((key==GLUT_KEY_UP)&&(near<0.1))
    {
      myTrans=near;
      myDisplay();
    }

  else if((key==GLUT_KEY_DOWN)&&(far>-9.9))
    {
      myTrans=far;
      myDisplay();
    }

}

int
main(int argc, char** argv)
{

  glutInit(&argc,argv);
  

  /*
  if(argc < 2)

    {
      printf("Anti [p](point sampling), [l](bilinear), or [m](mipmap)\n");
      return 1;
    }

  antiOption = *argv[1];
  */

  glutInitWindowSize(winWidth,winHeight);
  glutInitWindowPosition(0,50);
  glutCreateWindow("point sampling");
  glutDisplayFunc(myDisplay);
  glutReshapeFunc(myReshape);
  glClearColor(1.0, 1.0, 0.0, 1.0);
  glutSpecialFunc(mySpecial);
  antiOption='p';
  myInit();

  glutInitWindowSize(winWidth,winHeight);
  glutInitWindowPosition(310,50);
  glutCreateWindow("bilinear");
  glutDisplayFunc(myDisplay);
  glutReshapeFunc(myReshape);
  glClearColor(1.0, 1.0, 0.0, 1.0);
  glutSpecialFunc(mySpecial);
  antiOption='l';
  myInit();

  glutInitWindowSize(winWidth,winHeight);
  glutInitWindowPosition(620,50);
  glutCreateWindow("mipmap");
  glutDisplayFunc(myDisplay);
  glutReshapeFunc(myReshape);
  glClearColor(1.0, 1.0, 0.0, 1.0);
  glutSpecialFunc(mySpecial);
  antiOption='m';
  myInit();

  glutMainLoop();

  return 0;
  //glutMouseFunc(myMouse);
  //glutMotionFunc(myMotion);
}


